package com.yida.data.attendance.dto;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.yida.data.common.core.common.BaseDTO;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDate;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@Data
public class AttendanceResultPageDTO extends BaseDTO {

    @ApiModelProperty("学校id")
    private Long schoolId;

    @ApiModelProperty("宿舍楼id")
    private Long dormId;

    @ApiModelProperty("寝室id")
    private Long dormRoomId;

    @ApiModelProperty("开始日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate startDate;

    @ApiModelProperty("结束日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate endDate;

    @ApiModelProperty("规则id")
    private Long ruleId;

    @ApiModelProperty("校区id")
    private Long campusId;

    @ApiModelProperty("学段id")
    private Long sectionId;

    @ApiModelProperty("年级id")
    private Long gradeId;

    @ApiModelProperty("班级id")
    private Long classId;

    @ApiModelProperty("姓名/学号")
    private String keyword;

    @ApiModelProperty("类型，0-校门，1-宿舍(导出数据时传)")
    private Integer type;
}
