package com.yida.data.attendance.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yida.data.common.core.common.BaseDTO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@ApiModel("分页查询进出记录条件")
@Data
public class InOutPageDTO extends BaseDTO {

    @ApiModelProperty("学校id")
    private Long schoolId;

    @ApiModelProperty("宿舍楼id")
    private Long dormId;

    @ApiModelProperty("校区id")
    private Long campusId;

    @ApiModelProperty("学段id")
    private Long sectionId;

    @ApiModelProperty("年级id")
    private Long gradeId;

    @ApiModelProperty("班级id")
    private Long classId;

    @ApiModelProperty("姓名/学号")
    private String keyword;

    @ApiModelProperty("类型，0-校门，1-宿舍(导出数据时传)")
    private Integer type;

    @ApiModelProperty("开始时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime startTime;


    @ApiModelProperty("结束时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime endTime;
}
