package com.yida.data.attendance.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDate;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@ApiModel("查询考勤记录条件")
@Data
public class ListResultStatisticsDTO {

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    LocalDate date;
    Long schoolId;
    Long campusId;
    Long gradeId;
    Long classId;
    Long dormId;
    @ApiModelProperty("考勤类型，0-上学，1-归寝")
    Integer type;
    @ApiModelProperty("时段(校门考勤用)")
    Long timeId;
    @ApiModelProperty("时段(宿舍考勤用),1-中午，2-晚上")
    Integer duration;
}
