package com.yida.data.attendance.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDate;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@ApiModel("查询学生考勤记录")
@Data
public class ListStudentResultDTO {

    @ApiModelProperty("班级id")
    private Long classId;

    @ApiModelProperty("学生id")
    private Long studentId;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate startDate;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate endDate;

    @ApiModelProperty("0-正常,1-迟到,2-早退,3-旷课,4-晚归,6-旷宿,8-请假")
    private Integer type;

    @ApiModelProperty("规则时段id")
    private Long timeId;
}
