package com.yida.data.attendance.feign;

import com.yida.data.attendance.fallback.RemoteAttendanceResultServiceFallback;
import com.yida.data.common.core.common.ResultBean;
import com.yida.data.common.core.entity.constant.FebsServerConstant;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;

@FeignClient(value = FebsServerConstant.EDU_ATTENDANCE, contextId = "attendanceNotArriveServiceClient",
        fallbackFactory = RemoteAttendanceResultServiceFallback.class)
public interface RemoteAttendanceResultService {

    /**
     * 推送未到记录
     *
     * @return
     */
    @GetMapping("/in/result/pushNotArriveMsg")
    ResultBean pushNotArriveMsg();


    /**
     * 保存未到记录
     *
     * @return
     */
    @GetMapping("/in/result/dealAttendanceResult")
    ResultBean dealAttendanceResult();
}
