package com.yida.data.attendance.feign;

import com.yida.data.attendance.fallback.RemoteAttendanceRuleServiceFallback;
import com.yida.data.common.core.common.ResultBean;
import com.yida.data.common.core.entity.constant.FebsServerConstant;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;

@FeignClient(value = FebsServerConstant.EDU_ATTENDANCE, contextId = "attendanceRuleServiceClient",
        fallbackFactory = RemoteAttendanceRuleServiceFallback.class)
public interface RemoteAttendanceRuleService {

    /**
     * 更新规则状态
     *
     * @return
     */
    @GetMapping("/in/rule/updateRuleStatus")
    ResultBean updateRuleStatus();

    /**
     * 提醒打卡
     *
     * @param
     */
    @GetMapping("/in/staffRecord/remindStaff")
    ResultBean remindStaff();

    /**
     * 处理记录到结果表
     *
     * @param
     */
    @GetMapping("/in/staffRecord/staffRecord")
    ResultBean staffRecord();

}
