package com.yida.data.attendance.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.yida.data.common.core.converter.LocalDateTimeConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@ApiModel("宿舍考勤记录")
@Data
public class AttendanceResultDormVO extends AttendanceResultVO {

    @ApiModelProperty("宿舍寝室名称")
    @ExcelProperty(order = 4, value = "宿舍寝室名称")
    private String dormRoomName;

    @ApiModelProperty("核查状态")
    @ExcelProperty(order = 9, value = "核查状态")
    private String verify;

    @ApiModelProperty("核查时间")
    @ExcelProperty(order = 10, value = "核查时间", converter = LocalDateTimeConverter.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime verifyTime;

    @ApiModelProperty("核查人")
    @ExcelIgnore
    private Long verifyId;
}
