package com.yida.data.attendance.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.yida.data.common.core.converter.LocalDateConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDate;
import lombok.Data;

@ApiModel("考勤记录分页记录")
@Data
public class AttendanceResultVO {

    @ApiModelProperty("校区名称")
    @ExcelProperty(order = 0, value = "校区")
    private String campusName;

    @ApiModelProperty("年级班级")
    @ExcelProperty(order = 1, value = "年级班级")
    private String gradeClass;

    @ApiModelProperty("学生id")
    @ExcelIgnore
    private Long studentId;

    @ApiModelProperty("姓名")
    @ExcelProperty(order = 2, value = "姓名")
    private String stuName;

    @ApiModelProperty("学号")
    @ExcelProperty(order = 3, value = "学号")
    private String stuNumber;

    @ApiModelProperty("考勤日期")
    @ExcelProperty(order = 5, value = "考勤日期", converter = LocalDateConverter.class)
    private LocalDate attendanceDate;

    @ApiModelProperty("考勤规则id")
    @ExcelIgnore
    private Long ruleId;

    @ApiModelProperty("考勤规则名称")
    @ExcelProperty(order = 6, value = "考勤规则")
    private String ruleName;

    @ApiModelProperty("考勤时段")
    @ExcelProperty(order = 7, value = "考勤时段")
    private String time;

    @ApiModelProperty("考勤结果")
    @ExcelProperty(order = 8, value = "考勤结果")
    private String status;

    @ApiModelProperty("图片")
    @ExcelIgnore
    private String picUrl;
}
