package com.yida.data.attendance.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel("导出校门考勤率排名")
@Data
public class ExportSchoolRateVO {

    @ApiModelProperty("日期")
    @ExcelProperty(value = "日期", order = 0)
    private String date;

    @ApiModelProperty("时段")
    @ExcelIgnore
    private String time;

    @ApiModelProperty("校区")
    @ExcelProperty(value = "校区", order = 2)
    private String campus;

    @ApiModelProperty("年级班级")
    @ExcelProperty(value = "年级班级", order = 3)
    private String gradeClass;

    @ApiModelProperty("总人数")
    @ExcelProperty(value = "总人数", order = 4)
    private Integer total;

    @ApiModelProperty("出勤率")
    @ExcelProperty(value = "出勤率", order = 5)
    private Double rate;

    @ApiModelProperty("迟到")
    @ExcelProperty(value = {"考勤结果", "迟到"}, order = 6)
    private Integer late;

    @ApiModelProperty("早退")
    @ExcelProperty(value = {"考勤结果", "早退"}, order = 7)
    private Integer leave;

    @ApiModelProperty("迟到早退")
    @ExcelProperty(value = {"考勤结果", "迟到早退"}, order = 8)
    private Integer lateAndLeave;

    @ApiModelProperty("旷学")
    @ExcelProperty(value = {"考勤结果", "旷学"}, order = 9)
    private Integer notArrive;

    @ApiModelProperty("正常")
    @ExcelProperty(value = {"考勤结果", "正常"}, order = 10)
    private Integer normal;
}
