package com.yida.data.attendance.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.yida.data.common.core.converter.LocalDateTimeConverter;

import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class InOutPageVO {

    @ApiModelProperty("校区名称")
    @ExcelProperty(order = 0, value = "校区")
    private String campusName;

    @ApiModelProperty("年级班级")
    @ExcelProperty(order = 1, value = "年级班级")
    private String gradeClass;

    @ApiModelProperty("学生id")
    @ExcelIgnore
    private Long studentId;

    @ApiModelProperty("姓名")
    @ExcelProperty(order = 2, value = "姓名")
    private String stuName;

    @ApiModelProperty("学号")
    @ExcelProperty(order = 3, value = "学号")
    private String stuNumber;

    @ApiModelProperty("进出位置")
    @ExcelProperty(order = 5, value = "进出位置")
    private String zoneName;

    @ApiModelProperty("进出状态")
    @ExcelProperty(order = 6, value = "进出状态")
    private String scope;

    @ApiModelProperty("进出时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty(order = 7, value = "进出时间", converter = LocalDateTimeConverter.class)
    private LocalDateTime createTime;

    @ApiModelProperty("图片")
    @ExcelIgnore
    private String picUrl;
}
