package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;

import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class RateVO {

    @ApiModelProperty("班级")
    private String gradeClass;

    @ApiModelProperty("宿舍楼名称")
    private String dormName;

    @ApiModelProperty("出勤率")
    private Double rate;

    @ApiModelProperty("总人数")
    private Integer total;

    @ApiModelProperty("校区")
    private String campus;

    @ApiModelProperty("日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate date;

    @ApiModelProperty("时段")
    private String duration;

    @ApiModelProperty("迟到/晚归/异常晚归")
    private Integer late;

    @ApiModelProperty("早退")
    private Integer leave;

    @ApiModelProperty("迟到早退")
    private Integer lateAndLeave;

    @ApiModelProperty("旷学/旷宿")
    private Integer notArrive;

    @ApiModelProperty("正常")
    private Integer normal;

}
