package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@Data
@ApiModel("考勤记录")
public class RecordDetailVO {

    private Long id;

    private Long userId;
    @ApiModelProperty("学生名称")
    private String name;
    @ApiModelProperty("班级名称")
    private String className;

    @ApiModelProperty("学号")
    private String stuNumber;

    @ApiModelProperty("设备名称")
    private String deviceName;
    // 体温
    @ApiModelProperty("体温")
    private Double temp;
    @ApiModelProperty("考勤图片地址")
    private String picUrl;
    // 进出类型，0-进，1-出
    @ApiModelProperty("考勤区域类型，0-进门，1-出门")
    private Integer scope;
    @ApiModelProperty("考勤区域类型，0-校门，1-宿舍")
    private Integer zone;
    @ApiModelProperty("考勤时间")
    @DateTimeFormat(pattern = "HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "HH:mm:ss")
    private LocalDateTime createTime;
    @ApiModelProperty("考勤结果，//状态，0-正常，1-迟到，2-早退，3-未到")
    private Integer status;

    @ApiModelProperty("考勤时间，0-上午，1-下午，2-晚上")
    private Integer time;

    @ApiModelProperty("规定时间")
    private String stiTime;
}
