package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDate;
import java.time.LocalTime;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

@ApiModel("考勤记录信息")
@Data
public class ResultDetailVO {

    @ApiModelProperty("学生id")
    private Long studentId;

    @ApiModelProperty("学生名称")
    private String studentName;

    @ApiModelProperty("学号")
    private String studentNum;

    @ApiModelProperty("学生类型")
    private Integer studentType;

    @ApiModelProperty("考勤日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private LocalDate attendanceDate;

    @ApiModelProperty("生成该结果的第一条进出记录的时间")
    @DateTimeFormat(pattern = "HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "HH:mm:ss")
    private LocalTime recordTime;

    @ApiModelProperty("匹配的考勤规则的标准时间")
    @DateTimeFormat(pattern = "HH:mm")
    @JsonFormat(timezone = "GMT+8", pattern = "HH:mm")
    private LocalTime stiTime;

    @ApiModelProperty("生成该结果的第一条进出记录的设备名称")
    private String zoneName;

    @ApiModelProperty("旷课/请假：时段区间，旷宿：中午/晚上")
    private String ruleTime;

    @ApiModelProperty("考勤结果")
    private Integer status;
}
