package com.yida.data.attendance.vo;

import com.yida.data.common.core.entity.attendance.EduAttendanceRuleDate;
import com.yida.data.common.core.entity.attendance.EduAttendanceRuleDept;
import com.yida.data.common.core.entity.attendance.EduAttendanceRuleDevice;
import com.yida.data.common.core.entity.attendance.EduAttendanceRuleTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.List;

@Data
@ApiModel("规则列表数据实体")
public class RuleListVO {

    private Long id;

    @ApiModelProperty("规则名称")
    private String name;
    @ApiModelProperty("规则状态")
    private Integer status;
    @ApiModelProperty("规则类型，0-上学，1-归寝")
    private Integer type;

    @ApiModelProperty("创建时间")
    private LocalDateTime createDate;

    @ApiModelProperty("创建人id")
    private Long createId;

    @ApiModelProperty("创建者")
    private String createName;

    @ApiModelProperty("住宿生是否参与上学考勤")
    private Integer dormitoryFlag;

    private Long schoolId;

    @ApiModelProperty("适用对象")
    private List<EduAttendanceRuleDept> deptList;

    @ApiModelProperty("运行时间")
    private List<EduAttendanceRuleDate> dateList;

    @ApiModelProperty("考勤时间")
    private List<EduAttendanceRuleTime> timeList;

    @ApiModelProperty("考勤设备")
    private List<EduAttendanceRuleDevice> deviceList;

}
