package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @author ccl
 */
@Data
public class StaffRecordVO {

    @ApiModelProperty("记录id")
    private Long id;

    @ApiModelProperty("部门名称")
    private String deptName;

    @ApiModelProperty("员工id")
    private Long staffId;

    @ApiModelProperty("员工名称")
    private String staffName;

    @ApiModelProperty("手机号")
    private String phone;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("进出时间")
    private LocalDateTime time;

    @ApiModelProperty("星期")
    private String week;

    @ApiModelProperty("进出状态:0进1出")
    private Integer scope;

    @ApiModelProperty("进出位置")
    private String deviceName;

    @ApiModelProperty("图片链接")
    private String picUrl;
}
