package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;

import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalTime;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@ApiModel("住宿学生考勤记录")
@Data
public class StayStudentResultVO {

    @ApiModelProperty("学生头像")
    private String avatar;
    @ApiModelProperty("学号")
    private String studentNumber;
    @ApiModelProperty("学生id")
    private Long studentId;
    @ApiModelProperty("学生姓名")
    private String studentName;
    @ApiModelProperty("寝室名称")
    private String dormRoomName;
    @ApiModelProperty("考勤结果")
    private String result;
    @ApiModelProperty("归寝状态，0-在寝，1-未归")
    private Integer status;
    @ApiModelProperty("归寝时间")
    @DateTimeFormat(pattern = "HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "HH:mm:ss")
    private LocalTime time;
}
