package com.yida.data.attendance.vo;

import com.fasterxml.jackson.annotation.JsonFormat;

import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel("学生考勤信息")
public class StudentInfoVO {
    @ApiModelProperty("学生id")
    private Long studentId;

    @ApiModelProperty("学生姓名")
    private String name;
    @ApiModelProperty("学生头像")
    private String avatar;

    @ApiModelProperty("考勤时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime time;

    @ApiModelProperty("学生类型，0-走读，1-住宿")
    private Integer type;
    @ApiModelProperty("考勤结果，状态，0-正常，1-迟到，2-早退，3-迟到早退，4-未到，")
    private Integer result;
}
