package com.yida.data.attendance.controller.h5;

import com.yida.data.attendance.dto.ListRecordDTO;
import com.yida.data.attendance.service.EduAttendanceRecordService;
import com.yida.data.attendance.vo.RecordDetailVO;
import com.yida.data.common.core.common.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.List;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "考勤-前台-进出记录")
@RequiredArgsConstructor
@RestController
@RequestMapping("/h5/record")
public class H5EduAttendanceRecordController {

    private final EduAttendanceRecordService eduAttendanceRecordService;

    @ApiOperation("查询进出记录")
    @GetMapping("/listRecord")
    public ResultBean<List<RecordDetailVO>> listRecord(ListRecordDTO dto) {
        return ResultBean.buildSuccess(eduAttendanceRecordService.listRecord(dto));
    }

}
